Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.google.common.collect
Class LinkedListMultimap<K,V>

    java.lang.Object
      com.google.common.collect.LinkedListMultimap<K,V>

All Implemented Interfaces:
  ListMultimap<K,V>, Multimap<K,V>, Serializable

    public final class LinkedListMultimap<K,V>

extends Object
implements ListMultimap<K,V>, Serializable

An implementation of `ListMultimap` that supports deterministic iteration order for both keys and values. The iteration order is preserved across non-distinct key values. For example, for the following multimap definition:

       Multimap<K, V> multimap = LinkedListMultimap.create();
       multimap.put(key1, foo);
       multimap.put(key2, bar);
       multimap.put(key1, baz);

... the iteration order for `keys()` is `[key1, key2, key1]`, and similarly for `entries()`. Unlike `LinkedHashMultimap`, the iteration order is kept consistent between keys, entries and values. For example, calling:

       map.remove(key1, foo);

changes the entries iteration order to `[key2=bar, key1=baz]` and the key iteration order to `[key2, key1]`. The `entries()` iterator returns mutable map entries, and `replaceValues(K, java.lang.Iterable)` attempts to preserve iteration order as much as possible.

The collections returned by `keySet` and `asMap()` iterate through the keys in the order they were first added to the multimap. Similarly, `get(K)`, `removeAll(java.lang.Object)`, and `replaceValues(K, java.lang.Iterable)` return collections that iterate through the values in the order they were added. The collections generated by `entries`, `keys`, and `values()` iterate across the key-value mappings in the order they were added to the multimap.

Keys and values may be null. All optional multimap methods are supported, and all returned views are modifiable.

The methods `get(K)`, `keySet`, `keys`, `values()`, `entries`, and `asMap()` return collections that are views of the multimap. If the multimap is modified while an iteration over any of those collections is in progress, except through the iterator's own `remove` operation, the results of the iteration are undefined.

This class is not threadsafe when any concurrent operations update the multimap. Concurrent read operations will work correctly. To allow concurrent update operations, wrap your multimap with a call to `Multimaps.synchronizedListMultimap(com.google.common.collect.ListMultimap)`.

Author:
  Mike Bostock
See Also:
  Serialized Form

Method Summary
`Map<K,Collection<V>>` | `asMap()` Returns a map view that associates each key with the corresponding values in the multimap.
`void` | `clear()` Removes all key-value pairs from the multimap.
`boolean` | `containsEntry(Object key, Object value)` Returns `true` if the multimap contains the specified key-value pair.
`boolean` | `containsKey(Object key)` Returns `true` if the multimap contains any values for the specified key.
`boolean` | `containsValue(Object value)` Returns `true` if the multimap contains the specified value for any key.
`static
`<K,V> LinkedListMultimap<K,V>`
` | `create()` Creates a new, empty `LinkedListMultimap` with the default initial capacity.
`static
`<K,V> LinkedListMultimap<K,V>`
` | `create(int expectedKeys)` Constructs an empty `LinkedListMultimap` with enough capacity to hold the specified number of keys without rehashing.
`static
`<K,V> LinkedListMultimap<K,V>`
` | `create(Multimap<? extends K,? extends V> multimap)` Constructs a `LinkedListMultimap` with the same mappings as the specified `Multimap`.
`Collection<Map.Entry<K,V>>` | `entries()` Returns a collection of all key-value pairs.
`boolean` | `equals(Object other)` Compares the specified object to this multimap for equality.
`List<V>` | `get(K key)` Returns a collection view of all values associated with a key.
`int` | `hashCode()` Returns the hash code for this multimap.
`boolean` | `isEmpty()` Returns `true` if the multimap contains no key-value pairs.
`Multiset<K>` | `keys()` Returns a collection, which may contain duplicates, of all keys.
`Set<K>` | `keySet()` Returns the set of all keys, each appearing once in the returned set.
`boolean` | `put(K key, V value)` Stores a key-value pair in the multimap.
`boolean` | `putAll(K key, Iterable<? extends V> values)` Stores a collection of values with the same key.
`boolean` | `putAll(Multimap<? extends K,? extends V> multimap)` Copies all of another multimap's key-value pairs into this multimap.
`boolean` | `remove(Object key, Object value)` Removes a key-value pair from the multimap.
`List<V>` | `removeAll(Object key)` Removes all values associated with a given key.
`List<V>` | `replaceValues(K key, Iterable<? extends V> values)` Stores a collection of values with the same key, replacing any existing values for that key.
`int` | `size()` Returns the number of key-value pairs in the multimap.
`String` | `toString()` Returns a string representation of the multimap, generated by calling `toString` on the map returned by `Multimap.asMap()`.
`Collection<V>` | `values()` Returns a collection of all values in the multimap.

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Method Detail

### create

    public static <K,V> LinkedListMultimap<K,V> create()

  Creates a new, empty `LinkedListMultimap` with the default initial capacity.

### create

    public static <K,V> LinkedListMultimap<K,V> create(int expectedKeys)

  Constructs an empty `LinkedListMultimap` with enough capacity to hold the specified number of keys without rehashing.

  Parameters:
    `expectedKeys` - the expected number of distinct keys
  Throws:
    `IllegalArgumentException` - if `expectedKeys` is negative

### create

    public static <K,V> LinkedListMultimap<K,V> create(Multimap<? extends K,? extends V> multimap)

  Constructs a `LinkedListMultimap` with the same mappings as the specified `Multimap`. The new multimap has the same `Multimap.entries()` iteration order as the input multimap.

  Parameters:
    `multimap` - the multimap whose contents are copied to this multimap

### size

    public int size()

  Description copied from interface: `Multimap`
  Returns the number of key-value pairs in the multimap.

  Specified by:
    `size` in interface `Multimap<K,V>`

### isEmpty

    public boolean isEmpty()

  Description copied from interface: `Multimap`
  Returns `true` if the multimap contains no key-value pairs.

  Specified by:
    `isEmpty` in interface `Multimap<K,V>`

### containsKey

    public boolean containsKey(@Nullable
                               Object key)

  Description copied from interface: `Multimap`
  Returns `true` if the multimap contains any values for the specified key.

  Specified by:
    `containsKey` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to search for in multimap

### containsValue

    public boolean containsValue(@Nullable
                                 Object value)

  Description copied from interface: `Multimap`
  Returns `true` if the multimap contains the specified value for any key.

  Specified by:
    `containsValue` in interface `Multimap<K,V>`
  Parameters:
    `value` - value to search for in multimap

### containsEntry

    public boolean containsEntry(@Nullable
                                 Object key,
                                 @Nullable
                                 Object value)

  Description copied from interface: `Multimap`
  Returns `true` if the multimap contains the specified key-value pair.

  Specified by:
    `containsEntry` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to search for in multimap
    `value` - value to search for in multimap

### put

    public boolean put(@Nullable
                       K key,
                       @Nullable
                       V value)

  Stores a key-value pair in the multimap.

  Specified by:
    `put` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to store in the multimap
    `value` - value to store in the multimap
  Returns:
    `true` always

### remove

    public boolean remove(@Nullable
                          Object key,
                          @Nullable
                          Object value)

  Description copied from interface: `Multimap`
  Removes a key-value pair from the multimap.

  Specified by:
    `remove` in interface `Multimap<K,V>`
  Parameters:
    `key` - key of entry to remove from the multimap
    `value` - value of entry to remove the multimap
  Returns:
    `true` if the multimap changed

### putAll

    public boolean putAll(@Nullable
                          K key,
                          Iterable<? extends V> values)

  Description copied from interface: `Multimap`
  Stores a collection of values with the same key.

  Specified by:
    `putAll` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to store in the multimap
    `values` - values to store in the multimap
  Returns:
    `true` if the multimap changed

### putAll

    public boolean putAll(Multimap<? extends K,? extends V> multimap)

  Description copied from interface: `Multimap`
  Copies all of another multimap's key-value pairs into this multimap. The order in which the mappings are added is determined by `multimap.entries()`.

  Specified by:
    `putAll` in interface `Multimap<K,V>`
  Parameters:
    `multimap` - mappings to store in this multimap
  Returns:
    `true` if the multimap changed

### replaceValues

    public List<V> replaceValues(@Nullable
                                 K key,
                                 Iterable<? extends V> values)

  Stores a collection of values with the same key, replacing any existing values for that key.

  Because the values for a given key may have duplicates and follow the insertion ordering, this method returns a `List`, instead of the `Collection` specified in the `Multimap` interface.

  If any entries for the specified `key` already exist in the multimap, their values are changed in-place without affecting the iteration order.

  The returned list is immutable and implements `RandomAccess`.

  Specified by:
    `replaceValues` in interface `ListMultimap<K,V>`
  Specified by:
    `replaceValues` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to store in the multimap
    `values` - values to store in the multimap
  Returns:
    the collection of replaced values, or an empty collection if no values were previously associated with the key. The collection may be modifiable, but updating it will have no effect on the multimap.

### removeAll

    public List<V> removeAll(@Nullable
                             Object key)

  Removes all values associated with a given key.

  Because the values for a given key may have duplicates and follow the insertion ordering, this method returns a `List`, instead of the `Collection` specified in the `Multimap` interface.

  The returned list is immutable and implements `RandomAccess`.

  Specified by:
    `removeAll` in interface `ListMultimap<K,V>`
  Specified by:
    `removeAll` in interface `Multimap<K,V>`
  Parameters:
    `key` - key of entries to remove from the multimap
  Returns:
    the collection of removed values, or an empty collection if no values were associated with the provided key. The collection may be modifiable, but updating it will have no effect on the multimap.

### clear

    public void clear()

  Description copied from interface: `Multimap`
  Removes all key-value pairs from the multimap.

  Specified by:
    `clear` in interface `Multimap<K,V>`

### get

    public List<V> get(@Nullable
                       K key)

  Returns a collection view of all values associated with a key. If no mappings in the multimap have the provided key, an empty collection is returned.

  Changes to the returned collection will update the underlying multimap, and vice versa.

  Because the values for a given key may have duplicates and follow the insertion ordering, this method returns a `List`, instead of the `Collection` specified in the `Multimap` interface.

  If the multimap is modified while an iteration over the list is in progress (except through the iterator's own `add`, `set` or `remove` operations) the results of the iteration are undefined.

  The returned list is not serializable and does not have random access.

  Specified by:
    `get` in interface `ListMultimap<K,V>`
  Specified by:
    `get` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to search for in multimap
  Returns:
    the collection of values that the key maps to

### keySet

    public Set<K> keySet()

  Description copied from interface: `Multimap`
  Returns the set of all keys, each appearing once in the returned set. Changes to the returned set will update the underlying multimap, and vice versa.

  Specified by:
    `keySet` in interface `Multimap<K,V>`
  Returns:
    the collection of distinct keys

### keys

    public Multiset<K> keys()

  Description copied from interface: `Multimap`
  Returns a collection, which may contain duplicates, of all keys. The number of times of key appears in the returned multiset equals the number of mappings the key has in the multimap. Changes to the returned multiset will update the underlying multimap, and vice versa.

  Specified by:
    `keys` in interface `Multimap<K,V>`
  Returns:
    a multiset with keys corresponding to the distinct keys of the multimap and frequencies corresponding to the number of values that each key maps to

### values

    public Collection<V> values()

  Returns a collection of all values in the multimap. Changes to the returned collection will update the underlying multimap, and vice versa.

  The iterator generated by the returned collection traverses the values in the order they were added to the multimap.

  Specified by:
    `values` in interface `Multimap<K,V>`
  Returns:
    collection of values, which may include the same value multiple times if it occurs in multiple mappings

### entries

    public Collection<Map.Entry<K,V>> entries()

  Returns a collection of all key-value pairs. Changes to the returned collection will update the underlying multimap, and vice versa. The entries collection does not support the `add` or `addAll` operations.

  The iterator generated by the returned collection traverses the entries in the order they were added to the multimap.

  An entry's `Map.Entry.getKey()` method always returns the same key, regardless of what happens subsequently. As long as the corresponding key-value mapping is not removed from the multimap, `Map.Entry.getValue()` returns the value from the multimap, which may change over time, and `Map.Entry.setValue(V)` modifies that value. Removing the mapping from the multimap does not alter the value returned by `getValue()`, though a subsequent `setValue()` call won't update the multimap but will lead to a revised value being returned by `getValue()`.

  Specified by:
    `entries` in interface `Multimap<K,V>`
  Returns:
    collection of map entries consisting of key-value pairs

### asMap

    public Map<K,Collection<V>> asMap()

  Description copied from interface: `ListMultimap`
  Returns a map view that associates each key with the corresponding values in the multimap. Changes to the returned map, such as element removal, will update the underlying multimap. The map does not support `setValue()` on its entries, `put`, or `putAll`.

  The collections returned by `asMap().get(Object)` have the same behavior as those returned by `Multimap.get(K)`.

  Though the method signature doesn't say so explicitly, the returned map has `List` values.

  Specified by:
    `asMap` in interface `ListMultimap<K,V>`
  Specified by:
    `asMap` in interface `Multimap<K,V>`
  Returns:
    a map view from a key to its collection of values

### equals

    public boolean equals(@Nullable
                          Object other)

  Compares the specified object to this multimap for equality.

  Two `ListMultimap` instances are equal if, for each key, they contain the same values in the same order. If the value orderings disagree, the multimaps will not be considered equal.

  Specified by:
    `equals` in interface `ListMultimap<K,V>`
  Specified by:
    `equals` in interface `Multimap<K,V>`
  Overrides:
    `equals` in class `Object`
  Parameters:
    `other` - the reference object with which to compare.
  Returns:
    `true` if this object is the same as the obj argument; `false` otherwise.
  See Also:
    `Object.hashCode()`, `Hashtable`

### hashCode

    public int hashCode()

  Returns the hash code for this multimap.

  The hash code of a multimap is defined as the hash code of the map view, as returned by `Multimap.asMap()`.

  Specified by:
    `hashCode` in interface `Multimap<K,V>`
  Overrides:
    `hashCode` in class `Object`
  Returns:
    a hash code value for this object.
  See Also:
    `Object.equals(java.lang.Object)`, `Hashtable`

### toString

    public String toString()

  Returns a string representation of the multimap, generated by calling `toString` on the map returned by `Multimap.asMap()`.

  Overrides:
    `toString` in class `Object`
  Returns:
    a string representation of the multimap

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD